package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsBankActivityExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsBankActivityExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRegionsIsNull() {
            addCriterion("regions is null");
            return (Criteria) this;
        }

        public Criteria andRegionsIsNotNull() {
            addCriterion("regions is not null");
            return (Criteria) this;
        }

        public Criteria andRegionsEqualTo(String value) {
            addCriterion("regions =", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsNotEqualTo(String value) {
            addCriterion("regions <>", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsGreaterThan(String value) {
            addCriterion("regions >", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsGreaterThanOrEqualTo(String value) {
            addCriterion("regions >=", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsLessThan(String value) {
            addCriterion("regions <", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsLessThanOrEqualTo(String value) {
            addCriterion("regions <=", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsLike(String value) {
            addCriterion("regions like", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsNotLike(String value) {
            addCriterion("regions not like", value, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsIn(List<String> values) {
            addCriterion("regions in", values, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsNotIn(List<String> values) {
            addCriterion("regions not in", values, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsBetween(String value1, String value2) {
            addCriterion("regions between", value1, value2, "regions");
            return (Criteria) this;
        }

        public Criteria andRegionsNotBetween(String value1, String value2) {
            addCriterion("regions not between", value1, value2, "regions");
            return (Criteria) this;
        }

        public Criteria andActivityNoIsNull() {
            addCriterion("activity_no is null");
            return (Criteria) this;
        }

        public Criteria andActivityNoIsNotNull() {
            addCriterion("activity_no is not null");
            return (Criteria) this;
        }

        public Criteria andActivityNoEqualTo(Long value) {
            addCriterion("activity_no =", value, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoNotEqualTo(Long value) {
            addCriterion("activity_no <>", value, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoGreaterThan(Long value) {
            addCriterion("activity_no >", value, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoGreaterThanOrEqualTo(Long value) {
            addCriterion("activity_no >=", value, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoLessThan(Long value) {
            addCriterion("activity_no <", value, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoLessThanOrEqualTo(Long value) {
            addCriterion("activity_no <=", value, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoIn(List<Long> values) {
            addCriterion("activity_no in", values, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoNotIn(List<Long> values) {
            addCriterion("activity_no not in", values, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoBetween(Long value1, Long value2) {
            addCriterion("activity_no between", value1, value2, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNoNotBetween(Long value1, Long value2) {
            addCriterion("activity_no not between", value1, value2, "activityNo");
            return (Criteria) this;
        }

        public Criteria andActivityNameIsNull() {
            addCriterion("activity_name is null");
            return (Criteria) this;
        }

        public Criteria andActivityNameIsNotNull() {
            addCriterion("activity_name is not null");
            return (Criteria) this;
        }

        public Criteria andActivityNameEqualTo(String value) {
            addCriterion("activity_name =", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameNotEqualTo(String value) {
            addCriterion("activity_name <>", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameGreaterThan(String value) {
            addCriterion("activity_name >", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameGreaterThanOrEqualTo(String value) {
            addCriterion("activity_name >=", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameLessThan(String value) {
            addCriterion("activity_name <", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameLessThanOrEqualTo(String value) {
            addCriterion("activity_name <=", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameLike(String value) {
            addCriterion("activity_name like", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameNotLike(String value) {
            addCriterion("activity_name not like", value, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameIn(List<String> values) {
            addCriterion("activity_name in", values, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameNotIn(List<String> values) {
            addCriterion("activity_name not in", values, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameBetween(String value1, String value2) {
            addCriterion("activity_name between", value1, value2, "activityName");
            return (Criteria) this;
        }

        public Criteria andActivityNameNotBetween(String value1, String value2) {
            addCriterion("activity_name not between", value1, value2, "activityName");
            return (Criteria) this;
        }

        public Criteria andPosScopeIsNull() {
            addCriterion("pos_scope is null");
            return (Criteria) this;
        }

        public Criteria andPosScopeIsNotNull() {
            addCriterion("pos_scope is not null");
            return (Criteria) this;
        }

        public Criteria andPosScopeEqualTo(String value) {
            addCriterion("pos_scope =", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeNotEqualTo(String value) {
            addCriterion("pos_scope <>", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeGreaterThan(String value) {
            addCriterion("pos_scope >", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeGreaterThanOrEqualTo(String value) {
            addCriterion("pos_scope >=", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeLessThan(String value) {
            addCriterion("pos_scope <", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeLessThanOrEqualTo(String value) {
            addCriterion("pos_scope <=", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeLike(String value) {
            addCriterion("pos_scope like", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeNotLike(String value) {
            addCriterion("pos_scope not like", value, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeIn(List<String> values) {
            addCriterion("pos_scope in", values, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeNotIn(List<String> values) {
            addCriterion("pos_scope not in", values, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeBetween(String value1, String value2) {
            addCriterion("pos_scope between", value1, value2, "posScope");
            return (Criteria) this;
        }

        public Criteria andPosScopeNotBetween(String value1, String value2) {
            addCriterion("pos_scope not between", value1, value2, "posScope");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartIsNull() {
            addCriterion("effective_start is null");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartIsNotNull() {
            addCriterion("effective_start is not null");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartEqualTo(Date value) {
            addCriterion("effective_start =", value, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartNotEqualTo(Date value) {
            addCriterion("effective_start <>", value, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartGreaterThan(Date value) {
            addCriterion("effective_start >", value, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartGreaterThanOrEqualTo(Date value) {
            addCriterion("effective_start >=", value, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartLessThan(Date value) {
            addCriterion("effective_start <", value, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartLessThanOrEqualTo(Date value) {
            addCriterion("effective_start <=", value, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartIn(List<Date> values) {
            addCriterion("effective_start in", values, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartNotIn(List<Date> values) {
            addCriterion("effective_start not in", values, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartBetween(Date value1, Date value2) {
            addCriterion("effective_start between", value1, value2, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveStartNotBetween(Date value1, Date value2) {
            addCriterion("effective_start not between", value1, value2, "effectiveStart");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndIsNull() {
            addCriterion("effective_end is null");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndIsNotNull() {
            addCriterion("effective_end is not null");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndEqualTo(Date value) {
            addCriterion("effective_end =", value, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndNotEqualTo(Date value) {
            addCriterion("effective_end <>", value, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndGreaterThan(Date value) {
            addCriterion("effective_end >", value, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndGreaterThanOrEqualTo(Date value) {
            addCriterion("effective_end >=", value, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndLessThan(Date value) {
            addCriterion("effective_end <", value, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndLessThanOrEqualTo(Date value) {
            addCriterion("effective_end <=", value, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndIn(List<Date> values) {
            addCriterion("effective_end in", values, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndNotIn(List<Date> values) {
            addCriterion("effective_end not in", values, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndBetween(Date value1, Date value2) {
            addCriterion("effective_end between", value1, value2, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andEffectiveEndNotBetween(Date value1, Date value2) {
            addCriterion("effective_end not between", value1, value2, "effectiveEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartIsNull() {
            addCriterion("registration_start is null");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartIsNotNull() {
            addCriterion("registration_start is not null");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartEqualTo(Date value) {
            addCriterion("registration_start =", value, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartNotEqualTo(Date value) {
            addCriterion("registration_start <>", value, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartGreaterThan(Date value) {
            addCriterion("registration_start >", value, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartGreaterThanOrEqualTo(Date value) {
            addCriterion("registration_start >=", value, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartLessThan(Date value) {
            addCriterion("registration_start <", value, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartLessThanOrEqualTo(Date value) {
            addCriterion("registration_start <=", value, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartIn(List<Date> values) {
            addCriterion("registration_start in", values, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartNotIn(List<Date> values) {
            addCriterion("registration_start not in", values, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartBetween(Date value1, Date value2) {
            addCriterion("registration_start between", value1, value2, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationStartNotBetween(Date value1, Date value2) {
            addCriterion("registration_start not between", value1, value2, "registrationStart");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndIsNull() {
            addCriterion("registration_end is null");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndIsNotNull() {
            addCriterion("registration_end is not null");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndEqualTo(Date value) {
            addCriterion("registration_end =", value, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndNotEqualTo(Date value) {
            addCriterion("registration_end <>", value, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndGreaterThan(Date value) {
            addCriterion("registration_end >", value, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndGreaterThanOrEqualTo(Date value) {
            addCriterion("registration_end >=", value, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndLessThan(Date value) {
            addCriterion("registration_end <", value, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndLessThanOrEqualTo(Date value) {
            addCriterion("registration_end <=", value, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndIn(List<Date> values) {
            addCriterion("registration_end in", values, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndNotIn(List<Date> values) {
            addCriterion("registration_end not in", values, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndBetween(Date value1, Date value2) {
            addCriterion("registration_end between", value1, value2, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andRegistrationEndNotBetween(Date value1, Date value2) {
            addCriterion("registration_end not between", value1, value2, "registrationEnd");
            return (Criteria) this;
        }

        public Criteria andDetailsIsNull() {
            addCriterion("details is null");
            return (Criteria) this;
        }

        public Criteria andDetailsIsNotNull() {
            addCriterion("details is not null");
            return (Criteria) this;
        }

        public Criteria andDetailsEqualTo(String value) {
            addCriterion("details =", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsNotEqualTo(String value) {
            addCriterion("details <>", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsGreaterThan(String value) {
            addCriterion("details >", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsGreaterThanOrEqualTo(String value) {
            addCriterion("details >=", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsLessThan(String value) {
            addCriterion("details <", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsLessThanOrEqualTo(String value) {
            addCriterion("details <=", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsLike(String value) {
            addCriterion("details like", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsNotLike(String value) {
            addCriterion("details not like", value, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsIn(List<String> values) {
            addCriterion("details in", values, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsNotIn(List<String> values) {
            addCriterion("details not in", values, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsBetween(String value1, String value2) {
            addCriterion("details between", value1, value2, "details");
            return (Criteria) this;
        }

        public Criteria andDetailsNotBetween(String value1, String value2) {
            addCriterion("details not between", value1, value2, "details");
            return (Criteria) this;
        }

        public Criteria andCommentsIsNull() {
            addCriterion("comments is null");
            return (Criteria) this;
        }

        public Criteria andCommentsIsNotNull() {
            addCriterion("comments is not null");
            return (Criteria) this;
        }

        public Criteria andCommentsEqualTo(String value) {
            addCriterion("comments =", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsNotEqualTo(String value) {
            addCriterion("comments <>", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsGreaterThan(String value) {
            addCriterion("comments >", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsGreaterThanOrEqualTo(String value) {
            addCriterion("comments >=", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsLessThan(String value) {
            addCriterion("comments <", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsLessThanOrEqualTo(String value) {
            addCriterion("comments <=", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsLike(String value) {
            addCriterion("comments like", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsNotLike(String value) {
            addCriterion("comments not like", value, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsIn(List<String> values) {
            addCriterion("comments in", values, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsNotIn(List<String> values) {
            addCriterion("comments not in", values, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsBetween(String value1, String value2) {
            addCriterion("comments between", value1, value2, "comments");
            return (Criteria) this;
        }

        public Criteria andCommentsNotBetween(String value1, String value2) {
            addCriterion("comments not between", value1, value2, "comments");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}